/***************************************************************************
 *   Copyright (C) 2009 by Rico Rommel   *
 *   rico@bierrommel.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef DEVINTERFACE_H
#define DEVINTERFACE_H

#include <QWidget>
#include <QCheckBox>
#include <QComboBox>
#include <QtGui>
#include <QDBusConnection>
#include <QDBusInterface>
#include <QHBoxLayout>

#include "config.h"
#include "qcheckbutton.h"



class DeviceInterface : public QWidget
{
	Q_OBJECT

public:
    DeviceInterface(QString name, QWidget *parent, QStringList states);
    QString getPreventState();
    void setDBusArguments(QString service, QString path, QString interface, QString meth, QString arg, QStringList match);
     ~DeviceInterface();
    void saveSettings(QSettings *settings);
    void loadSettings( QSettings *settings);
protected:
    QComboBox *ComboBox;
    QStringList idlestates;
    QDBusInterface *dbusinterface;
    QString DBusMethod;
    QString CallArgument;
    QStringList DBusMatch;
    QCheckButton *CheckButton;
    QHBoxLayout * Layout;
    QString Name;

protected slots:
    void CheckButtonChanged( bool );
};

#endif